<?php

namespace App\Entity;

use ApiPlatform\Core\Annotation\ApiFilter;
use ApiPlatform\Core\Annotation\ApiProperty;
use ApiPlatform\Core\Annotation\ApiResource;
use App\Http\WebflowApi\WebflowApiCollectionItem;
use App\Filter\SearchFilter;

/**
 * @ApiResource(
 *  collectionOperations={"get"},
 *  itemOperations={"get"}
 * )
 * @ApiFilter(SearchFilter::class, properties={"cid": "exact"})
 */
class WebflowItem extends AbstractEntity {

    /**
     * @ApiProperty(identifier=true)
     */
    protected $id;

    private $cid;


    protected $archived;

    protected $draft;

    public function __construct(WebflowApiCollectionItem $webflowApiCollectionItem) {
        $this->setFromData($webflowApiCollectionItem->data);
    }

    public function getId(): ?string {
        return $this->id;
    }

    public function getCid(): ?string {
        return $this->cid;
    }

    public function setCid(string $cid): self {
        $this->cid = $cid;
        return $this;
    }

    public function getArchived(): bool {
        return $this->archived;
    }

    public function getDraft(): bool {
        return $this->draft;
    }

}
